//
// Communication Contention Model
//
// msg.h - Definition of the static message class
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_MSG
#define _INC_MSG

#include <iostream>

class msg {
public:
	msg(void);		            // Default Constructor
	msg(int,int,long);	        // Construct and set
	void set(int,int,long);	    // Set message config
	void print(std::ostream&);	// Print contents

	bool operator==(msg&);      // Compare messages
	bool operator!=(msg&);      // Compare messages

	int GetSrc(void) {          // Source processor
	    return src;
	};

	int GetTrg(void) {          // Target processor
	    return trg;
	};

	long GetLen(void){          // Message Length
	    return len;
	};

private:
	int src;		// Source processor
	int trg;		// Target processor
	long len;		// Message length
};

extern std::ostream &operator<<(std::ostream&, msg&);

#endif


	



