//
// Communication Contention Model
//
// myrinet.h - Definition of myrinet class
//
// NETSYS DERIVED CLASS
// MYRINET M2M-OCT-SW8 Interconection Network
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_MYRINET
#define _INC_MYRINET

#include <math.h>
#include "netsys.h"

#define MYRINET_PC      (16) // Max PCs on single switch

class myrinet : public netsys {
public:
    myrinet(int);
    ~myrinet();

    void Routing(int,int,unsigned char(*)[2]);  // Route a message
    int  GetLinkNo(void);           // Number of links on the system
    int  GetNproc(void);            // Get nprocs
    long Tcom(int,float);           // Communication delay in microsecs
    float T2Pack(long,int,float,float,long); // Given com time determine packets
    int  PacketSize(void);          // Size of each packet
    float (*GetBgrLoad(long))[2];   // Get background load vector
    const char* Name(void);         // System name

private:

    int   Nproc;
    float bgrl;                     // Background load
    float (*Vbgr)[2];               // Background vector
    int   Nlink;
};


#endif


