//
// Communication Contention Model
//
// netsys.h - Definition of the abstract system class
//
// WORKLOAD DERIVED CLASS
// Read & process ASCII workload traces
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_NETSYS
#define _INC_NETSYS

class netsys {
 public:
     virtual void   Routing(int,int,unsigned char(*)[2]) = 0;   // Route a message
     virtual int    GetLinkNo(void) = 0;                // Number of links
     virtual int    GetNproc(void) = 0;                 // Get number of procs
     virtual float  (*GetBgrLoad(long))[2] = 0;         // Get background load vector
     virtual long   Tcom(int,float) = 0;                // Communication delay in msecs
     virtual float  T2Pack(long,int,float,float,long) = 0; // Return packets that consumed in event
     virtual int    PacketSize(void) = 0;               // Size of packet in bytes
     virtual const char* Name(void) = 0;                // System name
};

#endif

