//
// Communication Contention Model
//
// otrace.h - Definition of output trace abstract class
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_OTRACE
#define _INC_OTRACE

class otrace {
 public:
    // Signal from evaleng -> otrace
    enum otrace_sig {
                            // Func         Parameters                   Position
        CONFIG,             // Go           nproc, nlink, workload, proc before main event loop
        GO_INIT,            // Go           sysname                      before main event loop
        GO_STARTEVENT,      // Go           event                        start of new event
        GO_END,             // Go           event                        end of evaluation
        CREATEEVENT ,       // CreateEvent  newev,oldev                  end of event creation
        NEWSCOM,            // NewScom      procid                       end of function
        NEWPROC,            // NewProc      procid,time                  end of function
        SYSCONT,            // SysCont      contention V                 end of function
        MSGCONT,            // MsgCont      procid,maxcont               for each processor
        COMMCOST,           // CommCost     procid,npack,hops,com cost   for each processor
        EVENTHORIZON,       // EventHorizon evhor                        end of function
        UPPR_PROC,          // UpdateProc   procid                       completion of proc event
        UPPR_SCOM,          // UpdateProc   srcp,trgp                    completion of scom event
        UPPR_PCNS,          // UpdateProc   srcp,trgp,packs              after calc packets consumed
        UPPR_END            // UpdateProc   sys clock                    end of function
    };

    virtual void   RecvSignal(otrace_sig ...)=0; // Receive an output trace signal from evaleng
};


#endif


