//
// Communication Contention Model
//
// otrdeb.h - Definition of otrdeb class
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_OTRDB
#define _INC_OTRDB

#include <iostream>
#include "otrace.h"

class otrdeb: public otrace {
 public:

    enum debug {
    	DBNONE = 0, // No debug output
	    DBWRK = 1,  // Workload 
	    DBROU = 2,  // Rooting
	    DBCNT = 4,  // Contention
	    DBEHR = 8,  // Event Horizon
	    DBCST = 16, // Comm cost
        DBEND = 32, // End of evaluation
	    DBALL = DBWRK|DBROU|DBCNT|DBEHR|DBCST|DBEND
    };

    otrdeb(debug,std::ostream*);
    void    RecvSignal(otrace_sig ...);

 private:
    int           db;  // Debug flags
    std::ostream* os;  // Output stream

    // evaleng configuration
    int         nproc;
    int         nlink;
    workload*   w;
    proc*       p;

    bool isdebug(debug);
};

#endif