// Communication Contention Model
//
// proc.cpp- Implementation of processor class
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#include "proc.h"

using namespace std;

proc::proc(void)
{
    pid = -1;       // Undefined
    clock = 0;
    evclock = 0;
    for( int i = 0; i < EVTYP_CNT; i++ )
        tmdec[i] = 0;
    cmsg = NULL;  // No active message
    cev = NACT;
}

void proc::MsgActivate(msg m, netsys* s)
{

  cmsg = new actmsg(m,s);

}

void proc::MsgComplete(void)
{
    delete cmsg;
    cmsg = NULL;
    cev = NACT;
}

void proc::print(ostream &os)
{
    os << "proc(" << pid << ") event " << cev << endl;
    os << "event clock " << evclock << " clock " << clock << endl;

    if( cmsg != NULL )
	    os << *cmsg;
}

ostream &operator<<(ostream &os, proc &p)
{
    p.print(os);

    return os;
}



