//
// CCMOD LIB
// Communication Contention Prediction Model Library
//
//
// Communication Contention Model
//
// workload.h - Definition of abstract workload class
//
// Stathis Papaefstathiou (efp@microsoft.com)
// Copyright (c) 2000 Microsoft Research Ltd. All rights reserved.
//

#ifndef _INC_WORKLOAD
#define _INC_WORKLOAD

class workload { // Abstract workload classs
public:

	enum trace {        // Tracetype
		TRACE_IDLE,		// Processor is idle
		TRACE_SCOM,		// Synchronous communication
		TRACE_END		// End of traces
	};

    virtual void    print(std::ostream&) = 0;			    	// Print workload debug info 
    virtual trace   GetTraceType(int procid) = 0;			    // Get type of trace
	virtual void    GetTraceData(int procid,int &src,
                    int &trg,long &len) = 0;				    // Get comm trace data
	virtual void    GetTraceData(int procid, long &time) = 0;	// Get idle processor trace data
    virtual trace   FetchNextTrace(int procid) = 0;             // Fetch next trace
};



#endif
